// *********************************************************************
//
//	unshrink.c
//
// *********************************************************************

#include "unzip.h"

extern	HWND	cwnd;

/*************************************/
/*  UnShrink Defines, Globals, etc.  */
/*************************************/

/*      MAX_BITS        13   (in unzip.h; defines size of global work area)  */
#define INIT_BITS       9
#define FIRST_ENT       257
#define CLEAR           256
#define GetCode(dest)   READBIT(codesize,dest)

void 	partial_clear( void );   /* local prototype */

int 	codesize, maxcode, maxcodemax, free_ent;




// *********************************************************************
//
//	unShrink()
//
// *********************************************************************
void unShrink( void )
{
int 	code;
int		stackp;
int 	finchar;
int 	oldcode;
int 	incode;
int		a;

	/* decompress the file */

	_fmemset( area, 0, (int) (((long)HSIZE+2L)*4L + 15L) );

    codesize			= INIT_BITS;			// 9
	maxcode				= (1 << codesize) - 1;	// 2^9-1 = 511
    maxcodemax			= HSIZE;         		// (1 << MAX_BITS) == 8192
	free_ent			= FIRST_ENT;			// 257

	code				= maxcodemax;			// code = 8192
	do
	{
		area->shrink.Prefix_of[code]	= -1;
    }while( --code > 255 );

	for (code = 255; code >= 0; code--)
	{
		prefix_of[code] = 0;
		suffix_of[code] = (BYTE) code;
    }

	/*
		At this point, prefix_of[] looks like this:
			prefix_of[0] - prefix_of[255] == 0;
			prefix_of[256] - prefix_of[ 8192 ] == -1;
    */


	GetCode(oldcode);				// Get the FIRST code
	if( zipeof )
        return;

	finchar = oldcode;

	OUTB(finchar);					// OUtput first char

	stackp = HSIZE;

	while( !zipeof )
	{
		GetCode( code );

		if (zipeof)
            return;

		// -----------------------------------------------
		//	Clearing
		// -----------------------------------------------
		while (code == CLEAR)
		{
			GetCode(code);
			switch (code)
			{
                case 1:
                    codesize++;
                    if (codesize == MAX_BITS)
                        maxcode = maxcodemax;
                    else
                        maxcode = (1 << codesize) - 1;
                    break;

                case 2:
                    partial_clear();
                    break;
            }

            GetCode(code);
            if (zipeof)
                return;
        }


		/* special case for KwKwK string */
        incode = code;
		if( prefix_of[code] == -1 )
		{
			stack[--stackp] = (BYTE) finchar;
            code = oldcode;
        }

        /* generate output characters in reverse order */
		while( code >= FIRST_ENT )
		{
			// Adding characters to stack
			if( prefix_of[code] == -1 )
			{
				stack[--stackp]		= (BYTE) finchar;
                code				= oldcode;
			}else{
				stack[--stackp]		= suffix_of[code];
				code				= prefix_of[code];
			}
		}

		finchar = suffix_of[code];
		stack[--stackp] = (BYTE) finchar;


        /* and put them out in forward order, block copy */
		if ((HSIZE - stackp + outcnt) < 2048 ) // OUTBUFSIZ)
		{
			_fmemcpy( (char FAR *)outptr, &stack[stackp], HSIZE - stackp);
			outptr += HSIZE - stackp;
			outcnt += HSIZE - stackp;
            stackp = HSIZE;
		}
        /* output byte by byte if we can't go by blocks */
		else
        {
			while (stackp < HSIZE)
            {
				OUTB(stack[stackp++]);
			}
		}

		/* generate new entry */
		code = free_ent;

		if( code < maxcodemax )
		{
			prefix_of[code] = oldcode;
			suffix_of[code] = (BYTE) finchar;

            do
                code++;
			while( (code < maxcodemax) && (prefix_of[code] != -1) );

            free_ent = code;
		}

		/* remember previous code */
        oldcode = incode;
    }


}



/******************************/
/*  Function partial_clear()  */
/******************************/

void partial_clear( void )
{
register	int		pr;
register	int		cd;

	/* mark all nodes as potentially unused */
    for (cd = FIRST_ENT; cd < free_ent; cd++)
        prefix_of[cd] |= 0x8000;

	/* unmark those that are used by other nodes */
	for (cd = FIRST_ENT; cd < free_ent; cd++)
	{
        pr = prefix_of[cd] & 0x7fff;				/* reference to another node? */
        if (pr >= FIRST_ENT)						/* flag node as referenced */
            prefix_of[pr] &= 0x7fff;
    }

    /* clear the ones that are still marked */
    for (cd = FIRST_ENT; cd < free_ent; cd++)
        if ((prefix_of[cd] & 0x8000) != 0)
            prefix_of[cd] = -1;

    /* find first cleared node as next free_ent */
    cd = FIRST_ENT;
    while ((cd < maxcodemax) && (prefix_of[cd] != -1))
        cd++;
    free_ent = cd;
}





