// *********************************************************************
//
//	FILE.C
//
// *********************************************************************

#include "unzip.h"

// *********************************************************************
//
//	FlushOutput()
//
// *********************************************************************
int TZipFile::FlushOutput( void )
{
int len;
	if (outcnt)
	{
		len = outcnt;
		_write( zip_out_file, (char *)outbuf, len );
		outpos += (long)outcnt;
    	outcnt = 0;
		outptr = outbuf;
	}
	return 0;
}



// *********************************************************************
//
//	open_output_file()
//
// *********************************************************************
int   TZipFile::open_output_file( void )
{
char	filename_buffer[ PATH_LEN ];
int		res;
char	*p, *q;

	if( zip_out_filename[ strlen( zip_out_filename ) - 1 ] == '\\' )
	{
		zip_out_filename[ strlen( zip_out_filename ) - 1 ] = '\0';

		if( chdir( zip_out_filename ) )
        {
			if( mkdir( zip_out_filename ) )
			{
				sprintf( err_msg, "Error creating directory: %s", zip_out_filename );
            ::MessageBox( cwnd, err_msg, "Status", MB_OK );
			}
		}
		out_msg( err_msg );
		return 0;
    }


	//
	//	Handle sub-directories
	//

	strcpy( filename_buffer, zip_out_filename );
	q = &filename_buffer[ strlen( destination_directory)+1 ];

	// If this file is in a directory, should we create the subdirectory?
	if( dir_flag )
	{
		while( p = strchr( q, '\\' ) )
		{
			*p = '\0';
			if( chdir( filename_buffer ) )
			{
				if( mkdir( filename_buffer ) )
				{
					return 0;
				}
			}
			q = p+1;
			*p = '\\';
		}
	}else{
		if( p = strrchr( global_filename, '\\' ) )
		{
			strcpy( zip_out_filename, destination_directory );
			strcat( zip_out_filename, "\\" );
			strcat( zip_out_filename, p+1 );
		}
	}

	res = 1;
	_fmode = O_BINARY;

	if( (zip_out_file = creat( zip_out_filename, S_IWRITE )) == -1 )
	{
		res = 0;
	}else{
		res = 1;
	}

	return res;
}



// *********************************************************************
//
//	FillBitBuffer()
//
// *********************************************************************
int TZipFile::FillBitBuffer( void )
{
    /*
     * Fill bitbuf, which is 32 bits.  This function is only used by the
     * READBIT and PEEKBIT macros (which are used by all of the uncompression
     * routines).
     */
	UWORD temp;

    zipeof = TRUE;
    while (bits_left < 25 && ReadByte(&temp) == 8)
    {
      bitbuf |= (ULONG)temp << bits_left;
      bits_left += 8;
	  zipeof = FALSE;
    }
	return 0;
}


// *********************************************************************
//
// ReadByte()
//
// *********************************************************************
int TZipFile::ReadByte( UWORD *x )
{
int		number_to_read;

	if( csize-- <= 0 )
		return 0;

	if( incnt == 0 )
	{
		number_to_read = min( lrec.compressed_size, (unsigned long) INBUFSIZ );

		incnt = _read( zip_in_file, inbuf, number_to_read );
		lrec.compressed_size -= number_to_read;
		if( incnt <= 0 )
			return 0;

		/* buffer ALWAYS starts on a block boundary:  */
		cur_zipfile_bufstart += min( lrec.compressed_size, (unsigned long) INBUFSIZ );
		inptr = inbuf;
	}

	*x = *inptr++;
	incnt--;

	return 8;
}


