// *********************************************************************
//
//	unreduce.c
//
// *********************************************************************

#include "unzip.h"


/**************************************/
/*  UnReduce Defines, Typedefs, etc.  */
/**************************************/

// *********************************************************************
//
//	UnReduce()
//
// *********************************************************************
void TZipFile::unReduce()   /* expand probabilistically reduced data */
{
register 	int lchar		= 0;
int 		nchar;
int 		ExState			= 0;
int 		V				= 0;
int 		Len				= 0;
long 		s				= ucsize;	/* number of bytes left to decompress */
unsigned 	w				= 0;		/* position in output window slide[] */
unsigned 	u				= 1;		/* true if slide[] unflushed */

	followers = (f_array FAR *) (&slide[0x4000] );

	factor = lrec.compression_method - 1;
    LoadFollowers();

	while (s > 0)
	{
        if (Slen[lchar] == 0)
            READBIT(8, nchar)   /* ; */
        else {
            READBIT(1, nchar);
            if (nchar != 0)
                READBIT(8, nchar)       /* ; */
            else {
                int follower;
                int bitsneeded = B_table[Slen[lchar]];
                READBIT(bitsneeded, follower);
                nchar = followers[lchar][follower];
            }
        }
        /* expand the resulting byte */
		switch (ExState)
		{
	        case 0:
				if( nchar != DLE )
				{
        	        s--;
            	    slide[w++] = (BYTE) nchar;
					if( w == 0x4000 )
					{
						xflush(w);
	                    w = u = 0;
    	            }
        	    }
            	else
                	ExState = 1;
            	break;

        	case 1:
				if (nchar != 0)
				{
                	V = nchar;
                	Len = V & L_table[factor];
                	if( Len == L_table[factor] )
                    	ExState = 2;
                	else
                    	ExState = 3;
            	}else{
                	s--;
                	slide[w++] = DLE;
                	if (w == 0x4000)
                	{
				  		xflush(w);
                  		w = u = 0;
                	}
                	ExState = 0;
            	}
            	break;

			case 2:
				{
                	Len += nchar;
	                ExState = 3;
    	        }
        		break;

			case 3:
				{
                register unsigned e;
                register unsigned n = Len + 3;
                register unsigned d = w - ((((V >> D_shift[factor]) &
                               		D_mask[factor]) << 8) + nchar + 1);
					s -= n;
					do
					{
						n -= (e = (e = 0x4000 - ((d &= 0x3fff) > w ? d : w)) > n ? n : e);
						if (u && w <= d)
						{
							_fmemset(slide + w, 0, e);
							w += e;
							d += e;
						}
						else
							if (w - d < e)	/* (assume unsigned comparison) */
								do {		/* slow to avoid memcpy() overlap */
								slide[w++] = slide[d++];
								} while (--e);
							else
							{
								_fmemcpy(slide + w, slide + d, e);
								w += e;
								d += e;
							}
						if( w == 0x4000 )
						{
							xflush(w);
							w = u = 0;
						}
					} while (n);

                	ExState = 0;
            	}
            	break;
        }

        /* store character for next iteration */
        lchar = nchar;
    }

	/* xflush out slide */
	xflush(w);
}

/******************************/
/*  Function LoadFollowers()  */
/******************************/

void TZipFile::LoadFollowers( void )
{
    register int x;
    register int i;

    for (x = 255; x >= 0; x--) {
        READBIT(6, Slen[x]);
        for (i = 0; (BYTE) i < Slen[x]; i++) {
            READBIT(8, followers[x][i]);
        }
    }
}


/* Do the equivalent of OUTB for the bytes slide[0..w-1]. */
void TZipFile::xflush( unsigned w )
{
  unsigned n;
  BYTE FAR *p;

  p = slide;
  while (w)
  {
    n = (n = OUTBUFSIZ - outcnt) < w ? n : w;
    _fmemcpy((char FAR *)outptr, p, n);       /* try to fill up buffer */
    outptr += n;
	if ((outcnt += n) == OUTBUFSIZ)
	  FlushOutput();            /* if full, empty */
    p += n;
    w -= n;
  }
}


